#include <stdio.h>
#include <netdb.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

#define SERV_PORT 5134

#define MAXNAME 1024

main(int argc, char **argv)
{
int fd;
int i;
int length;
char buf[MAXNAME];
struct hostent *hp;
struct sockaddr_in myaddr;
struct sockaddr_in servaddr;

    if(argc !=3) {
	fprintf(stderr, "Usage: %s user server\n", argv[0]);
	exit(2);
    }
    
    if( (fd=socket(AF_INET, SOCK_STREAM, 0)) < 0 ) {
    	perror("socket failed");
    	exit(1);	
    }	
    
    bzero((char *)&myaddr, sizeof(myaddr));
    myaddr.sin_family=AF_INET;
    myaddr.sin_addr.s_addr=htonl(INADDR_ANY);
    myaddr.sin_port=htons(0);
    
    if( bind(fd, (struct sockaddr *)&myaddr, sizeof(myaddr)) < 0) {
    	perror("bind failed");
    	exit(1);
    }
    
    bzero((char *)&servaddr, sizeof(servaddr));
    servaddr.sin_family =AF_INET;
    servaddr.sin_port=htons(SERV_PORT);
    
    hp=gethostbyname(argv[2]);
    
    if(hp==0) {
    	fprintf(stderr, "could not obtain address of %s\n", argv[2]);
    	exit(1);
    }
    
    bcopy(hp->h_addr_list[0], (caddr_t)&servaddr.sin_addr, hp->h_length);

    if( connect(fd, (struct sockaddr *)&servaddr, sizeof(servaddr)) < 0 ) {
    	perror("connect failed");
    	exit(1);
    }
    
    for(i=1; i<argc-1; i++) { 
    	
    	length=strlen(argv[i]) + 1;
    	if(write(fd, argv[i], length) != length) {
    		perror("write failed\n");
    		exit(1);
    	}	
    	
    	if(read(fd, buf, 1) == -1) {
    		perror("read failed\n");
    		exit(1);
    	}
    	
    	if(buf[0] == 'y') { 
    		fprintf(stderr, "\n%s esta dado de alta\n", argv[1]);
    	}
    	else {
    		fprintf(stderr, "\n%s no esta dado de alta\n", argv[1]);
	}
    
    
    }
    
    (void)shutdown(fd, 2);
    
    exit(0);
 
}
