#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <sys/errno.h>

#define SERV_PORT 5134

#define MAXNAME 1024

extern int errno;

main()
{
int socket_fd;
int recfd;
int length;
struct sockaddr_in myaddr;
struct sockaddr_in client_addr;

    if( (socket_fd=socket(AF_INET, SOCK_STREAM, 0)) < 0 ) {
    	perror("socket failed");
    	exit(1);    
    }
    
    bzero((char *)&myaddr, sizeof(myaddr));
    myaddr.sin_family=AF_INET;
    myaddr.sin_addr.s_addr=htonl(INADDR_ANY);
    myaddr.sin_port=htons(SERV_PORT);
    
    if( bind(socket_fd, (struct sockaddr *)&myaddr, sizeof(myaddr)) < 0) {
    	perror("bind failed");
    	exit(1);
    }
    
    if(listen(socket_fd, 5) < 0){
    	perror("listen falied");
    	exit(1);
    }
 
    length=sizeof(client_addr);
    
    while(1) {
    	if( (recfd=accept(socket_fd, (struct sockaddr *)&client_addr,
    	                  &length) ) < 0) {
    		perror("could not accept call");
    		exit(1);	                  
    	 }
    	 
    	 switch (fork()) {
    	 	case -1:
    	 		perror("fork failed\n");
    	 		exit(1);
    	 
    	 	default: /* parent */
    	 		close(recfd);
    	 		break;
    	 	
    	 	case 0: /* child */
    	 		close(socket_fd);

    	 		perform_actions(recfd);
    	 }
 
    }
    
}

perform_actions(int conn_fd)
{
int done=0;
int where=0;
int nbytes;
char reply;
char buf[BUFSIZ];
char cmd[BUFSIZ];
char junkbuf[BUFSIZ];

FILE *fp;

    for(;;) {
    
    	where = 0;
    	do {
    	    if( (BUFSIZ-where) == 0 ) {
    	    	exit(1);
    	    }
    	    if( (nbytes=read(conn_fd, &buf[where], BUFSIZ-where)) < 0 ) {
    		if(errno != ECONNRESET) {
    			perror("read of data failed");
    			exit(1);
    		}    
    		else {
    			exit(0);
    		}
    	    }
    	    
    	    where+=nbytes;
    	    if( buf[where-1] == '\0' ) {
    	    	done=1;
    	    }

    	} while(!done);
    	sprintf(cmd, "who|grep %s", buf);
    

	if((fp=popen(cmd, "r")) == NULL 
		|| fgets(junkbuf, BUFSIZ, fp) == NULL ) {	
    		reply='n';	
    	}
    	else {
    		reply='y';
    	}
    	
    	if(write(conn_fd, &reply, 1) < 0) {
    		perror("write failed");
    		exit(1);
    	}
   	  		
       
    }

}
    	 
    	 
